module Paysure
    class GetToken < Paysure::RequestBase
      include Validatable
      attr_accessor :merchant_id,:callback_url, :amount,:data_request
      attr_reader   :response,:config
      validates_presence_of :amount
      validates_length_of :amount, :within => 1000..500000000
      validates_format_of :amount, :with => /^\d*$/, :if => Proc.new { !amount.nil? }
      
      def initialize(args = {})
        super
        @ACTION_NAME = [:get_token,'json'].join('.').freeze
        @amount      = args.fetch(:amount)
        @callback_url = args.fetch(:callback_url,Paysure.configuration.callback_url)
        @merchant_id = args.fetch(:merchant_id,Paysure.configuration.merchant_id)
        @response    = ResponseGetToken.new
      end
      
      
      def call
          connection = Faraday.new(url: "#{@API_URL}/transaction/") do |faraday|
            faraday.adapter Faraday.default_adapter
            faraday.response :json
          end
            response = connection.get(@ACTION_NAME, callback_url: @callback_url, amount: @amount,merchant_id: @merchant_id)
            @response.validate(response.body)
      end
      
    end
  
  end 
  