module Paysure
    class Verify < Paysure::RequestBase
      include Validatable
      attr_accessor :merchant_id, :token
      attr_reader   :response,:config
      validates_presence_of :token

      def initialize(args = {})
        super
        @ACTION_NAME = [:verify,'json'].join('.').freeze
        @token       = args.fetch(:token)
        @merchant_id = args.fetch(:merchant_id,Paysure.configuration.merchant_id)
        @response    = ResponseVerify.new
      end
      
      
      def call
          connection = Faraday.new(url: "#{@API_URL}/transaction/") do |faraday|
            faraday.adapter Faraday.default_adapter
            faraday.response :json
          end
            response = connection.get(@ACTION_NAME, token: @token,merchant_id: @merchant_id)
            @response.validate(response.body)
      end
      
    end
  
  end 
  